;; -*- coding: utf-8  -*-
;;; oald7u-pkg.el --- Lookup supplement package for oald7-fuw
;; Copyright (C) 2010  Kazuhiro Ito <kzhr@d1.dion.ne.jp>

;; Author: Kazuhiro Ito <kzhr@d1.dion.nejp>
;; Target: ndebs, ndeb
;; Format: 1.1
;; Version: 1.0

;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software Foundation,
;; Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;;; Code:

(require 'lookup-package)

(defconst oald7u-dictionary-options
  (list
   (cons ':adjusts
	 '(lookup-adjust-check-references
	   lookup-adjust-show-gaijis
	   oald7u-adjust-goto))
   (cons ':backward-methods '(keyword))))

(defun oald7u-adjust-goto (entry)
  (goto-char (point-min))
  (let ((string (lookup-entry-heading entry))
	(head "")
	tail)
    (when (and (string-match "^\\[[a-zA-Z]+\\]\\(.+\\)$" string)
	       (setq tail (match-string 1 string))
	       (re-search-forward
		(progn
		  (while (string-match "^\\([^ ]*\\)\\( +\\)\\(.*\\)" tail)
		    (setq head (concat head (match-string 1 tail) "[ \t\n]+")
			  tail (match-string 3 tail)))
		  (concat head tail))
		nil t))
      (goto-char (match-beginning 0)))))

(setq lookup-package-dictionary-options-alist
      (list (cons "oald7"
		  oald7u-dictionary-options)))

;; oald7u-pkg.el ends
